- Main Page
- Classes
- Files
- Directories
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# OGRGeometry Class Reference

`#include <ogr_geometry.h>`

Inheritance diagram for OGRGeometry:

List of all members.

## Public Member Functions
virtual int | getDimension () const =0
virtual int | getCoordinateDimension () const
virtual OGRBoolean | IsEmpty () const
virtual OGRBoolean | IsSimple () const
virtual void | empty ()=0
virtual OGRGeometry * | clone () const =0
virtual void | getEnvelope (OGREnvelope *psEnvelope) const =0
virtual int | WkbSize () const =0
virtual OGRErr | importFromWkb (unsigned char *, int=-1)=0
virtual OGRErr | exportToWkb (OGRwkbByteOrder, unsigned char *) const =0
virtual OGRErr | importFromWkt (char **ppszInput)=0
virtual OGRErr | exportToWkt (char **ppszDstText) const =0
virtual OGRwkbGeometryType | getGeometryType () const =0
virtual const char * | getGeometryName () const =0
virtual void | dumpReadable (FILE *, const char *=NULL)
virtual void | flattenTo2D ()=0
virtual char * | exportToGML () const
virtual void | closeRings ()
virtual void | setCoordinateDimension (int nDimension)
void | assignSpatialReference (OGRSpatialReference *poSR)
OGRSpatialReference * | getSpatialReference (void) const
virtual OGRErr | transform (OGRCoordinateTransformation *poCT)=0
OGRErr | transformTo (OGRSpatialReference *poSR)
virtual OGRBoolean | Intersects (OGRGeometry *) const
virtual OGRBoolean | Equals (OGRGeometry *) const =0
virtual OGRBoolean | Disjoint (const OGRGeometry *) const
virtual OGRBoolean | Touches (const OGRGeometry *) const
virtual OGRBoolean | Crosses (const OGRGeometry *) const
virtual OGRBoolean | Within (const OGRGeometry *) const
virtual OGRBoolean | Contains (const OGRGeometry *) const
virtual OGRBoolean | Overlaps (const OGRGeometry *) const
virtual OGRGeometry * | getBoundary () const
virtual double | Distance (const OGRGeometry *) const
virtual OGRGeometry * | ConvexHull () const
virtual OGRGeometry * | Buffer (double dfDist, int nQuadSegs=30) const
virtual OGRGeometry * | Intersection (const OGRGeometry *) const
virtual OGRGeometry * | Union (const OGRGeometry *) const
virtual OGRGeometry * | Difference (const OGRGeometry *) const
virtual OGRGeometry * | SymmetricDifference (const OGRGeometry *) const

## Detailed Description

Abstract base class for all geometry classes.

Note that the family of spatial analysis methods (Equal(), Disjoint(), ..., ConvexHull(), Buffer(), ...) are not implemented at ths time. Some other required and optional geometry methods have also been omitted at this time.

## Member Function Documentation

void OGRGeometry::assignSpatialReference | ( | OGRSpatialReference * | poSR | ) |

  | Assign spatial reference to this object. Any existing spatial reference is replaced, but under no circumstances does this result in the object being reprojected. It is just changing the interpretation of the existing geometry. Note that assigning a spatial reference increments the reference count on the OGRSpatialReference, but does not copy it. This is similar to the SFCOM IGeometry::put_SpatialReference() method. This method is the same as the C function OGR_G_AssignSpatialReference(). Parameters:
  | poSR | new spatial reference system to apply.

OGRGeometry * OGRGeometry::Buffer | ( | double | dfDist,
|  | int | nQuadSegs = `30`
| ) | const`[virtual]`

  | Compute buffer of geometry. Builds a new geometry containing the buffer region around the geometry on which it is invoked. The buffer is a polygon containing the region within the buffer distance of the original geometry. Some buffer sections are properly described as curves, but are converted to approximate polygons. The nQuadSegs parameter can be used to control how many segements should be used to define a 90 degree curve - a quadrant of a circle. A value of 30 is a reasonable default. Large values result in large numbers of vertices in the resulting buffer geometry while small numbers reduce the accuracy of the result. This method is the same as the C function OGR_G_Buffer(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Parameters:
  | dfDist | the buffer distance to be applied.
  | nQuadSegs | the number of segments used to approximate a 90 degree (quadrant) of curvature.
Returns: the newly created geometry, or NULL if an error occurs.

OGRGeometry * OGRGeometry::clone | ( |  | ) | const`[pure virtual]`

| Make a copy of this object. This method relates to the SFCOM IGeometry::clone() method. This method is the same as the C function OGR_G_Clone(). Returns: a new object instance with the same geometry, and spatial reference system as the original. Implemented in OGRPoint, OGRLineString, OGRLinearRing, OGRPolygon, OGRGeometryCollection, OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

void OGRGeometry::closeRings | ( |  | ) | `[virtual]`

| Force rings to be closed. If this geometry, or any contained geometries has polygon rings that are not closed, they will be closed by adding the starting point at the end. Reimplemented in OGRLinearRing, OGRPolygon, and OGRGeometryCollection.

OGRBoolean OGRGeometry::Contains | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

  | Test for containment. Tests if the passed in geometry contains the target geometry. This method is the same as the C function OGR_G_Contains(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Parameters:
  | poOtherGeom | the geometry to compare to this geometry.
Returns: TRUE if poOtherGeom contains this geometry, otherwise FALSE.

OGRGeometry * OGRGeometry::ConvexHull | ( |  | ) | const`[virtual]`

| Compute convex hull. A new geometry object is created and returned containing the convex hull of the geometry on which the method is invoked. This method is the same as the C function OGR_G_ConvexHull(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Returns: a newly allocated geometry now owned by the caller, or NULL on failure.

OGRBoolean OGRGeometry::Crosses | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

  | Test for crossing. Tests if this geometry and the other passed into the method are crossing. This method is the same as the C function OGR_G_Crosses(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Parameters:
  | poOtherGeom | the geometry to compare to this geometry.
Returns: TRUE if they are crossing, otherwise FALSE.

OGRGeometry * OGRGeometry::Difference | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

  | Compute difference. Generates a new geometry which is the region of this geometry with the region of the second geometry removed. This method is the same as the C function OGR_G_Difference(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Parameters:
  | poOtherGeom | the other geometry removed from "this" geometry.
Returns: a new geometry representing the difference or NULL if the difference is empty or an error occurs.

OGRBoolean OGRGeometry::Disjoint | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

  | Test for disjointness. Tests if this geometry and the other passed into the method are disjoint. This method is the same as the C function OGR_G_Disjoint(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Parameters:
  | poOtherGeom | the geometry to compare to this geometry.
Returns: TRUE if they are disjoint, otherwise FALSE.

double OGRGeometry::Distance | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

  | Compute distance between two geometries. Returns the shortest distance between the two geometries. This method is the same as the C function OGR_G_Distance(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Parameters:
  | poOtherGeom | the other geometry to compare against.
Returns: the distance between the geometries or -1 if an error occurs.

void OGRGeometry::dumpReadable | ( | FILE * | fp,
|  | const char * | pszPrefix = `NULL`
| ) | `[virtual]`

  | Dump geometry in well known text format to indicated output file. This method is the same as the C function OGR_G_DumpReadable(). Parameters:
  | fp | the text file to write the geometry to.
  | pszPrefix | the prefix to put on each line of output.

void OGRGeometry::empty | ( |  | ) | `[pure virtual]`

| Clear geometry information. This restores the geometry to it's initial state after construction, and before assignment of actual geometry. This method relates to the SFCOM IGeometry::Empty() method. This method is the same as the C function OGR_G_Empty(). Implemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

int OGRGeometry::Equals | ( | OGRGeometry * | poOtherGeom | ) | const`[pure virtual]`

| Returns two if two geometries are equivalent. This method is the same as the C function OGR_G_Equal(). Returns: TRUE if equivalent or FALSE otherwise. Implemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

char * OGRGeometry::exportToGML | ( |  | ) | const`[virtual]`

| Convert a geometry into GML format. The GML geometry is expressed directly in terms of GML basic data types assuming the this is available in the gml namespace. The returned string should be freed with CPLFree() when no longer required. This method is the same as the C function OGR_G_ExportToGML(). Returns: A GML fragment or NULL in case of error.

OGRErr OGRGeometry::exportToWkb | ( | OGRwkbByteOrder | eByteOrder,
|  | unsigned char * | pabyData
| ) | const`[pure virtual]`

  | Convert a geometry into well known binary format. This method relates to the SFCOM IWks::ExportToWKB() method. This method is the same as the C function OGR_G_ExportToWkb(). Parameters:
  | eByteOrder | One of wkbXDR or wkbNDR indicating MSB or LSB byte order respectively.
  | pabyData | a buffer into which the binary representation is written. This buffer must be at least OGRGeometry::WkbSize() byte in size.
Returns: Currently OGRERR_NONE is always returned. Implemented in OGRPoint, OGRLineString, OGRLinearRing, OGRPolygon, and OGRGeometryCollection.

OGRErr OGRGeometry::exportToWkt | ( | char ** | ppszDstText | ) | const`[pure virtual]`

  | Convert a geometry into well known text format. This method relates to the SFCOM IWks::ExportToWKT() method. This method is the same as the C function OGR_G_ExportToWkt(). Parameters:
  | ppszDstText | a text buffer is allocated by the program, and assigned to the passed pointer.
Returns: Currently OGRERR_NONE is always returned. Implemented in OGRPoint, OGRLineString, OGRPolygon, OGRGeometryCollection, OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

void OGRGeometry::flattenTo2D | ( |  | ) | `[pure virtual]`

| Convert geometry to strictly 2D. In a sense this converts all Z coordinates to 0.0. This method is the same as the C function OGR_G_FlattenTo2D(). Implemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

OGRGeometry * OGRGeometry::getBoundary | ( |  | ) | const`[virtual]`

| Compute boundary. A new geometry object is created and returned containing the boundary of the geometry on which the method is invoked. This method is the same as the C function OGR_G_GetBoundary(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Returns: a newly allocated geometry now owned by the caller, or NULL on failure.

int OGRGeometry::getCoordinateDimension | ( |  | ) | const`[virtual]`

| Get the dimension of the coordinates in this object. This method corresponds to the SFCOM IGeometry::GetDimension() method. This method is the same as the C function OGR_G_GetCoordinateDimension(). Returns: in practice this always returns 2 indicating that coordinates are specified within a two dimensional space.

int OGRGeometry::getDimension | ( |  | ) | const`[pure virtual]`

| Get the dimension of this object. This method corresponds to the SFCOM IGeometry::GetDimension() method. It indicates the dimension of the object, but does not indicate the dimension of the underlying space (as indicated by OGRGeometry::getCoordinateDimension()). This method is the same as the C function OGR_G_GetDimension(). Returns: 0 for points, 1 for lines and 2 for surfaces. Implemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

void OGRGeometry::getEnvelope | ( | OGREnvelope * | psEnvelope | ) | const`[pure virtual]`

  | Computes and returns the bounding envelope for this geometry in the passed psEnvelope structure. This method is the same as the C function OGR_G_GetEnvelope(). Parameters:
  | psEnvelope | the structure in which to place the results.
Implemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

const char * OGRGeometry::getGeometryName | ( |  | ) | const`[pure virtual]`

| Fetch WKT name for geometry type. There is no SFCOM analog to this method. This method is the same as the C function OGR_G_GetGeometryName(). Returns: name used for this geometry type in well known text format. The returned pointer is to a static internal string and should not be modified or freed. Implemented in OGRPoint, OGRLineString, OGRLinearRing, OGRPolygon, OGRGeometryCollection, OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

OGRwkbGeometryType OGRGeometry::getGeometryType | ( |  | ) | const`[pure virtual]`

| Fetch geometry type. Note that the geometry type may include the 2.5D flag. To get a 2D flattened version of the geometry type apply the wkbFlatten() macro to the return result. This method is the same as the C function OGR_G_GetGeometryType(). Returns: the geometry type code. Implemented in OGRPoint, OGRLineString, OGRPolygon, OGRGeometryCollection, OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

OGRSpatialReference * OGRGeometry::getSpatialReference | ( | void |  | ) | const`[inline]`

| Returns spatial reference system for object. This method relates to the SFCOM IGeometry::get_SpatialReference() method. This method is the same as the C function OGR_G_GetSpatialReference(). Returns: a reference to the spatial reference object. The object may be shared with many geometry objects, and should not be modified.

OGRErr OGRGeometry::importFromWkb | ( | unsigned char * | pabyData,
|  | int | nSize = `-1`
| ) | `[pure virtual]`

  | Assign geometry from well known binary data. The object must have already been instantiated as the correct derived type of geometry object to match the binaries type. This method is used by the OGRGeometryFactory class, but not normally called by application code. This method relates to the SFCOM IWks::ImportFromWKB() method. This method is the same as the C function OGR_G_ImportFromWkb(). Parameters:
  | pabyData | the binary input data.
  | nSize | the size of pabyData in bytes, or zero if not known.
Returns: OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned. Implemented in OGRPoint, OGRLineString, OGRLinearRing, OGRPolygon, and OGRGeometryCollection.

OGRErr OGRGeometry::importFromWkt | ( | char ** | ppszInput | ) | `[pure virtual]`

  | Assign geometry from well known text data. The object must have already been instantiated as the correct derived type of geometry object to match the text type. This method is used by the OGRGeometryFactory class, but not normally called by application code. This method relates to the SFCOM IWks::ImportFromWKT() method. This method is the same as the C function OGR_G_ImportFromWkt(). Parameters:
  | ppszInput | pointer to a pointer to the source text. The pointer is updated to pointer after the consumed text.
Returns: OGRERR_NONE if all goes well, otherwise any of OGRERR_NOT_ENOUGH_DATA, OGRERR_UNSUPPORTED_GEOMETRY_TYPE, or OGRERR_CORRUPT_DATA may be returned. Implemented in OGRPoint, OGRLineString, OGRPolygon, OGRGeometryCollection, OGRMultiPolygon, OGRMultiPoint, and OGRMultiLineString.

OGRGeometry * OGRGeometry::Intersection | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

  | Compute intersection. Generates a new geometry which is the region of intersection of the two geometries operated on. The Intersect() method can be used to test if two geometries intersect. This method is the same as the C function OGR_G_Intersection(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Parameters:
  | poOtherGeom | the other geometry intersected with "this" geometry.
Returns: a new geometry representing the intersection or NULL if there is no intersection or an error occurs.

OGRBoolean OGRGeometry::Intersects | ( | OGRGeometry * | poOtherGeom | ) | const`[virtual]`

  | Do these features intersect? Determines whether two geometries intersect. If GEOS is enabled, then this is done in rigerous fashion otherwise TRUE is returned if the envelopes (bounding boxes) of the two features overlap. The poOtherGeom argument may be safely NULL, but in this case the method will always return TRUE. That is, a NULL geometry is treated as being everywhere. This method is the same as the C function OGR_G_Intersects(). Parameters:
  | poOtherGeom | the other geometry to test against.
Returns: TRUE if the geometries intersect, otherwise FALSE.

OGRBoolean OGRGeometry::IsEmpty | ( |  | ) | const`[inline, virtual]`

| Returns TRUE (non-zero) if the object has no points. Normally this returns FALSE except between when an object is instantiated and points have been assigned. This method relates to the SFCOM IGeometry::IsEmpty() method. NOTE: This method is hardcoded to return FALSE at this time. Returns: TRUE if object is empty, otherwise FALSE.

OGRBoolean OGRGeometry::IsSimple | ( |  | ) | const`[inline, virtual]`

| Returns TRUE if the geometry is simple. Returns TRUE if the geometry has no anomalous geometric points, such as self intersection or self tangency. The description of each instantiable geometric class will include the specific conditions that cause an instance of that class to be classified as not simple. This method relates to the SFCOM IGeometry::IsSimple() method. NOTE: This method is hardcoded to return TRUE at this time. Returns: TRUE if object is simple, otherwise FALSE.

OGRBoolean OGRGeometry::Overlaps | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

  | Test for overlap. Tests if this geometry and the other passed into the method overlap, that is their intersection has a non-zero area. This method is the same as the C function OGR_G_Overlaps(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Parameters:
  | poOtherGeom | the geometry to compare to this geometry.
Returns: TRUE if they are overlapping, otherwise FALSE.

void OGRGeometry::setCoordinateDimension | ( | int | nNewDimension | ) | `[virtual]`

  | Set the coordinate dimension. This method sets the explicit coordinate dimension. Setting the coordinate dimension of a geometry to 2 should zero out any existing Z values. Setting the dimension of a geometry collection will not necessarily affect the children geometries. Parameters:
  | nNewDimension | New coordinate dimension value, either 2 or 3.
Reimplemented in OGRLineString, OGRPolygon, and OGRGeometryCollection.

OGRGeometry * OGRGeometry::SymmetricDifference | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

  | Compute symmetric difference. Generates a new geometry which is the symmetric difference of this geometry and the second geometry passed into the method. This method is the same as the C function OGR_G_SymmetricDifference(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Parameters:
  | poOtherGeom | the other geometry.
Returns: a new geometry representing the symmetric difference or NULL if the difference is empty or an error occurs.

OGRBoolean OGRGeometry::Touches | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

  | Test for touching. Tests if this geometry and the other passed into the method are touching. This method is the same as the C function OGR_G_Touches(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Parameters:
  | poOtherGeom | the geometry to compare to this geometry.
Returns: TRUE if they are touching, otherwise FALSE.

OGRErr OGRGeometry::transform | ( | OGRCoordinateTransformation * | poCT | ) | `[pure virtual]`

  | Apply arbitrary coordinate transformation to geometry. This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units. Note that this method does not require that the geometry already have a spatial reference system. It will be assumed that they can be treated as having the source spatial reference system of the OGRCoordinateTransformation object, and the actual SRS of the geometry will be ignored. On successful completion the output OGRSpatialReference of the OGRCoordinateTransformation will be assigned to the geometry. This method is the same as the C function OGR_G_Transform(). Parameters:
  | poCT | the transformation to apply.
Returns: OGRERR_NONE on success or an error code. Implemented in OGRPoint, OGRLineString, OGRPolygon, and OGRGeometryCollection.

OGRErr OGRGeometry::transformTo | ( | OGRSpatialReference * | poSR | ) |

  | Transform geometry to new spatial reference system. This method will transform the coordinates of a geometry from their current spatial reference system to a new target spatial reference system. Normally this means reprojecting the vectors, but it could include datum shifts, and changes of units. This method will only work if the geometry already has an assigned spatial reference system, and if it is transformable to the target coordinate system. Because this method requires internal creation and initialization of an OGRCoordinateTransformation object it is significantly more expensive to use this method to transform many geometries than it is to create the OGRCoordinateTransformation in advance, and call transform() with that transformation. This method exists primarily for convenience when only transforming a single geometry. This method is the same as the C function OGR_G_TransformTo(). Parameters:
  | poSR | spatial reference system to transform to.
Returns: OGRERR_NONE on success, or an error code.

OGRGeometry * OGRGeometry::Union | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

  | Compute union. Generates a new geometry which is the region of union of the two geometries operated on. This method is the same as the C function OGR_G_Union(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Parameters:
  | poOtherGeom | the other geometry unioned with "this" geometry.
Returns: a new geometry representing the union or NULL if an error occurs.

OGRBoolean OGRGeometry::Within | ( | const OGRGeometry * | poOtherGeom | ) | const`[virtual]`

  | Test for containment. Tests if the passed in geometry is within the target geometry. This method is the same as the C function OGR_G_Within(). This method is built on the GEOS library, check it for the definition of the geometry operation. If OGR is built without the GEOS library, this method will always fail, issuing a CPLE_NotSupported error. Parameters:
  | poOtherGeom | the geometry to compare to this geometry.
Returns: TRUE if poOtherGeom is within this geometry, otherwise FALSE.

int OGRGeometry::WkbSize | ( |  | ) | const`[pure virtual]`

| Returns size of related binary representation. This method returns the exact number of bytes required to hold the well known binary representation of this geometry object. Its computation may be slightly expensive for complex geometries. This method relates to the SFCOM IWks::WkbSize() method. This method is the same as the C function OGR_G_WkbSize(). Returns: size of binary representation in bytes. Implemented in OGRPoint, OGRLineString, OGRLinearRing, OGRPolygon, and OGRGeometryCollection.

The documentation for this class was generated from the following files:

- ogr_geometry.h
- ogrgeometry.cpp

Generated for GDAL by 1.4.5.